# 内核启动 #



## SBI ##

在QEMU上，GalaxyOS采用 `OpenSBI` 作为系统的SBI。与我们基于的 `xv6-k210` 操作系统不同，我们没有使用 `RustSBI` ，因为 `RustSBI` 在评测机与我们测试系统的QEMU中均会陷入无限的死循环，导致无法进入内核。



## 内存空间 ##

在QEMU上，操作系统的内存地址从`0x80000000`开始，但是需要预留空间给SBI，因此实际内核的起始地址为`0x80200000`。



## 入口 ##

当RISC-V计算机开机时，它会初始化自己，并运行一个存储在只读存储器中的`boot loader`。`Boot loader`将内核加载到内存中。然后，在机器模式下，CPU从 `_entry`（kernel/entry_qemu.S:3）开始执行操作系统。RISC-V在禁用分页硬件的情况下启动：虚拟地址直接映射到物理地址。

在这里，`hartid`被放在a0中，分配好每个CPU核心的栈后，跳转至`main.c`。`main.c`会依次初始化各个系统，并唤醒其他CPU核心。`userinit()`函数（kernel/main.c:62）会初始化一个用户进程，即第一个用户进程。



## 第一个用户进程 ##

`userinit()`通过`kernel/initcode.S`得知第一个用户进程的代码，它记录了`user/initcode.S`代码的起始位置和结束位置，而实际的进程代码在`user/init.c`中。

该进程的作用便是启用标准输入输出，并依次执行SD卡镜像中的测试用例，最后执行关机系统调用。
