#ifndef __MM_H
#define __MM_H

#include "types.h"

#define PROT_NONE      0x0
#define PROT_READ      0x1  // page can be read
#define PROT_WRITE     0x2  // page can be written
#define PROT_EXEC      0x4  // page can be executed
#define PROT_GROWSDOWN 0X01000000
#define PROT_GROWSUP   0X02000000

#define MAP_FILE       0
#define MAP_SHARED     0x01
#define MAP_PRIVATE    0X02
#define MAP_FIXED      0x10
#define MAP_ANONYMOUS  0x20
#define MAP_FAILED     ((void *) -1)

enum seg_type { NONE, LOAD, TEXT, DATA, BSS, HEAP, MMAP, STACK };

struct seg {
	int valid;
	enum seg_type type;

	uint64 addr; // segment start address
	uint64 sz; // segment size
	uint64 mmap;
	uint64 f_off;
	int flag;
};

int new_seg(enum seg_type type, uint64 start, uint64 sz, int flag);
int locate_seg(enum seg_type type, uint64 start, uint sz);

#endif