#ifndef __SYSNUM_H
#define __SYSNUM_H

// System call numbers
// 0. Origin
#define SYS_fork           1
#define SYS_wait           2
#define SYS_pipe           3
#define SYS_kill           4
#define SYS_exec           5
#define SYS_sbrk           6
#define SYS_sleep          7
#define SYS_uptime         8
#define SYS_open           9
#define SYS_remove        10
#define SYS_trace         11
#define SYS_sysinfo       12
#define SYS_mkdir         13
#define SYS_test_proc     14
#define SYS_dev           15
#define SYS_readdir       16
#define SYS_rename        18
// Extra
#define SYS_shutdown      19

// 1. File system
#define SYS_getcwd        17
#define SYS_dup           23
#define SYS_chdir         49
#define SYS_close         57
#define SYS_read          63
#define SYS_write         64
#define SYS_fstat         80

#define SYS_pipe2         59
#define SYS_dup2          24
#define SYS_openat        56
#define SYS_getdents64    61
#define SYS_linkat        37
#define SYS_unlinkat      35
#define SYS_mkdirat       34
#define SYS_umount2       39
#define SYS_mount         40

// 2. Process management
#define SYS_exit          93
#define SYS_getpid       172
#define SYS_clone        220
#define SYS_execve       221
#define SYS_waitpid      260
#define SYS_getppid      173

// 3. Memory Management
#define SYS_brk          214
#define SYS_munmap       215
#define SYS_mmap         222

// 4. Others
#define SYS_times        153
#define SYS_uname        160
#define SYS_sched_yield  124
#define SYS_gettimeofday 169
#define SYS_nanosleep    101

#endif