// init: The initial user-level program

#include "kernel/include/types.h"
#include "kernel/include/file.h"
#include "kernel/include/fcntl.h"
#include "xv6-user/user.h"

char *syscall[] = {
  "brk",
  "chdir",
  "clone",
  "close",
  "dup",
  "dup2",
  "execve",
  "exit",
  "fork",
  "fstat",
  "getcwd",
  "getdents",
  "getpid",
  "getppid",
  "gettimeofday",
  "mkdir_",
  "mmap",
  "mount",
  "munmap",
  "open",
  "openat",
  "pipe",
  "read",
  "sleep",
  "times",
  "umount",
  "uname",
  "unlink",
  "wait",
  "waitpid",
  "write",
  "yield",
};

char* argv[] = { NULL };

int
main(void)
{
  dev(O_RDWR, CONSOLE, 0);
  dup(0);  // stdout
  dup(0);  // stderr

  int i, pid;
  for(i = 0; i < sizeof(syscall)/sizeof(char*); ++i){
    pid = fork();

    if(pid == 0)
      exec(syscall[i], argv);
    else
      wait(0);
  }

  shutdown();

  return 0;
}
